Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/TRP/trcldf.F90	(revision 9019)
@@ -17,5 +17,6 @@
    USE trc            ! ocean passive tracers variables
    USE oce_trc        ! ocean dynamics and active tracers
-   USE ldfslp         ! lateral diffusion: iso-neutral slope
+   USE ldftra         ! lateral diffusion: eddy diffusivity & EIV coeff.
+   USE ldfslp         ! Lateral diffusion: slopes of neutral surfaces
    USE traldf_lap_blp ! lateral diffusion: lap/bilaplacian iso-level      operator  (tra_ldf_lap/_blp   routine)
    USE traldf_iso     ! lateral diffusion: laplacian iso-neutral standard operator  (tra_ldf_iso        routine)
@@ -32,4 +33,5 @@
    PUBLIC   trc_ldf_ini   
    !
+   LOGICAL , PUBLIC ::   ln_trcldf_NONE      !: No operator (no explicit lateral diffusion)
    LOGICAL , PUBLIC ::   ln_trcldf_lap       !:   laplacian operator
    LOGICAL , PUBLIC ::   ln_trcldf_blp       !: bilaplacian operator
@@ -45,5 +47,5 @@
    REAL(wp) ::  rldf       ! ratio between active and passive tracers diffusive coefficient
    
-   INTEGER  ::  nldf = 0   ! type of lateral diffusion used defined from ln_trcldf_... namlist logicals)
+   INTEGER  ::  nldf       ! type of lateral diffusion used defined from ln_trcldf_... namlist logicals)
    
    !! * Substitutions
@@ -98,14 +100,10 @@
       CASE ( np_lap   )                               ! iso-level laplacian
          CALL tra_ldf_lap  ( kt, nittrc000,'TRC', zahu, zahv, gtru, gtrv, gtrui, gtrvi, trb,      tra, jptra,  1   )
-         !
       CASE ( np_lap_i )                               ! laplacian : standard iso-neutral operator (Madec)
          CALL tra_ldf_iso  ( kt, nittrc000,'TRC', zahu, zahv, gtru, gtrv, gtrui, gtrvi, trb, trb, tra, jptra,  1   )
-         !
       CASE ( np_lap_it )                              ! laplacian : triad iso-neutral operator (griffies)
          CALL tra_ldf_triad( kt, nittrc000,'TRC', zahu, zahv, gtru, gtrv, gtrui, gtrvi, trb, trb, tra, jptra,  1   )
-         !
       CASE ( np_blp , np_blp_i , np_blp_it )          ! bilaplacian: all operator (iso-level, -neutral)
          CALL tra_ldf_blp  ( kt, nittrc000,'TRC', zahu, zahv, gtru, gtrv, gtrui, gtrvi, trb     , tra, jptra, nldf )
-         !
       END SELECT
       !
@@ -148,5 +146,5 @@
       NAMELIST/namtrc_ldf/ ln_trcldf_lap, ln_trcldf_blp,                                  &
          &                 ln_trcldf_lev, ln_trcldf_hor, ln_trcldf_iso, ln_trcldf_triad,  &
-         &                 rn_ahtrc_0   , rn_bhtrc_0, rn_fact_lap  
+         &                 rn_ahtrc_0   , rn_bhtrc_0   , rn_fact_lap  
       !!----------------------------------------------------------------------
       !
@@ -166,4 +164,5 @@
          WRITE(numout,*) '   Namelist namtrc_ldf : set lateral mixing parameters (type, direction, coefficients)'
          WRITE(numout,*) '      operator'
+         WRITE(numout,*) '         no explicit diffusion       ln_trcldf_NONE  = ', ln_trcldf_NONE
          WRITE(numout,*) '           laplacian                 ln_trcldf_lap   = ', ln_trcldf_lap
          WRITE(numout,*) '         bilaplacian                 ln_trcldf_blp   = ', ln_trcldf_blp
@@ -182,85 +181,88 @@
       !                                ! control the namelist parameters
       ioptio = 0
-      IF( ln_trcldf_lap )   ioptio = ioptio + 1
-      IF( ln_trcldf_blp )   ioptio = ioptio + 1
-      IF( ioptio >  1   )   CALL ctl_stop( 'trc_ldf_ctl: use ONE or NONE of the 2 lap/bilap operator type on tracer' )
-      IF( ioptio == 0   )   nldf = np_no_ldf   ! No lateral diffusion
+      IF( ln_trcldf_NONE ) THEN   ;   nldf = np_no_ldf   ;   ioptio = ioptio + 1   ;   ENDIF
+      IF( ln_trcldf_lap  ) THEN   ;                          ioptio = ioptio + 1   ;   ENDIF
+      IF( ln_trcldf_blp  ) THEN   ;                          ioptio = ioptio + 1   ;   ENDIF
+      IF( ioptio /=  1   )   CALL ctl_stop( 'trc_ldf_ini: use ONE of the 3 operator options (NONE/lap/blp)' )
       
-      IF( ln_trcldf_lap .AND. ln_trcldf_blp )   CALL ctl_stop( 'trc_ldf_ctl: bilaplacian should be used on both TRC and TRA' )
-      IF( ln_trcldf_blp .AND. ln_trcldf_lap )   CALL ctl_stop( 'trc_ldf_ctl:   laplacian should be used on both TRC and TRA' )
-      !
-      ioptio = 0
-      IF( ln_trcldf_lev )   ioptio = ioptio + 1
-      IF( ln_trcldf_hor )   ioptio = ioptio + 1
-      IF( ln_trcldf_iso )   ioptio = ioptio + 1
-      IF( ioptio /= 1   )   CALL ctl_stop( 'trc_ldf_ctl: use only ONE direction (level/hor/iso)' )
-      !
-      ! defined the type of lateral diffusion from ln_trcldf_... logicals
-      ! CAUTION : nldf = 1 is used in trazdf_imp, change it carefully
-      ierr = 0
-      IF( ln_trcldf_lap ) THEN      !==  laplacian operator  ==!
-         IF ( ln_zco ) THEN                ! z-coordinate
-            IF ( ln_trcldf_lev   )   nldf = np_lap     ! iso-level = horizontal (no rotation)
-            IF ( ln_trcldf_hor   )   nldf = np_lap     ! iso-level = horizontal (no rotation)
-            IF ( ln_trcldf_iso   )   nldf = np_lap_i   ! iso-neutral: standard  (   rotation)
-            IF ( ln_trcldf_triad )   nldf = np_lap_it  ! iso-neutral: triad     (   rotation)
+      IF( ln_trcldf_lap .AND. .NOT.ln_traldf_lap )   CALL ctl_stop( 'trc_ldf_ini:   laplacian should be used on both TRC and TRA' )
+      IF( ln_trcldf_blp .AND. .NOT.ln_traldf_blp )   CALL ctl_stop( 'trc_ldf_ini: bilaplacian should be used on both TRC and TRA' )
+      !
+      IF( .NOT.ln_trcldf_NONE ) THEN   ! direction ==>> type of operator 
+         ioptio = 0
+         IF( ln_trcldf_lev )   ioptio = ioptio + 1
+         IF( ln_trcldf_hor )   ioptio = ioptio + 1
+         IF( ln_trcldf_iso )   ioptio = ioptio + 1
+         IF( ioptio /= 1   )   CALL ctl_stop( 'trc_ldf_ini: use ONE direction (level/hor/iso)' )
+         !
+         ! defined the type of lateral diffusion from ln_trcldf_... logicals
+         ! CAUTION : nldf = 1 is used in trazdf_imp, change it carefully
+         ierr = 0
+         IF( ln_trcldf_lap ) THEN      !==  laplacian operator  ==!
+            IF( ln_zco ) THEN                ! z-coordinate
+               IF( ln_trcldf_lev   )   nldf = np_lap     ! iso-level = horizontal (no rotation)
+               IF( ln_trcldf_hor   )   nldf = np_lap     ! iso-level = horizontal (no rotation)
+               IF( ln_trcldf_iso   )   nldf = np_lap_i   ! iso-neutral: standard  (   rotation)
+               IF( ln_trcldf_triad )   nldf = np_lap_it  ! iso-neutral: triad     (   rotation)
+            ENDIF
+            IF( ln_zps ) THEN             ! z-coordinate with partial step
+               IF( ln_trcldf_lev   )   ierr = 1          ! iso-level not allowed 
+               IF( ln_trcldf_hor   )   nldf = np_lap     ! horizontal (no rotation)
+               IF( ln_trcldf_iso   )   nldf = np_lap_i   ! iso-neutral: standard (rotation)
+               IF( ln_trcldf_triad )   nldf = np_lap_it  ! iso-neutral: triad    (rotation)
+            ENDIF
+            IF( ln_sco ) THEN             ! s-coordinate
+               IF( ln_trcldf_lev   )   nldf = np_lap     ! iso-level  (no rotation)
+               IF( ln_trcldf_hor   )   nldf = np_lap_it  ! horizontal (   rotation)       !!gm   a checker....
+               IF( ln_trcldf_iso   )   nldf = np_lap_i   ! iso-neutral: standard (rotation)
+               IF( ln_trcldf_triad )   nldf = np_lap_it  ! iso-neutral: triad    (rotation)
+            ENDIF
+            !                                ! diffusivity ratio: passive / active tracers 
+            IF( ABS(rn_aht_0) < 2._wp*TINY(1._wp) ) THEN
+               IF( ABS(rn_ahtrc_0) < 2._wp*TINY(1._wp) ) THEN
+                  rldf = 1.0_wp
+               ELSE
+                  CALL ctl_stop( 'trc_ldf_ctl : cannot define rldf, rn_aht_0==0, rn_ahtrc_0 /=0' )
+               ENDIF
+            ELSE
+               rldf = rn_ahtrc_0 / rn_aht_0
+            ENDIF
          ENDIF
-         IF ( ln_zps ) THEN             ! z-coordinate with partial step
-            IF ( ln_trcldf_lev   )   ierr = 1         ! iso-level not allowed 
-            IF ( ln_trcldf_hor   )   nldf = np_lap     ! horizontal (no rotation)
-            IF ( ln_trcldf_iso   )   nldf = np_lap_i   ! iso-neutral: standard (rotation)
-            IF ( ln_trcldf_triad )   nldf = np_lap_it  ! iso-neutral: triad    (rotation)
+         !
+         IF( ln_trcldf_blp ) THEN      !==  bilaplacian operator  ==!
+            IF ( ln_zco ) THEN                ! z-coordinate
+               IF ( ln_trcldf_lev   )   nldf = np_blp     ! iso-level = horizontal (no rotation)
+               IF ( ln_trcldf_hor   )   nldf = np_blp     ! iso-level = horizontal (no rotation)
+               IF ( ln_trcldf_iso   )   nldf = np_blp_i   ! iso-neutral: standard (rotation)
+               IF ( ln_trcldf_triad )   nldf = np_blp_it  ! iso-neutral: triad    (rotation)
+            ENDIF
+            IF ( ln_zps ) THEN             ! z-coordinate with partial step
+               IF ( ln_trcldf_lev   )   ierr = 1         ! iso-level not allowed 
+               IF ( ln_trcldf_hor   )   nldf = np_blp     ! horizontal (no rotation)
+               IF ( ln_trcldf_iso   )   nldf = np_blp_i   ! iso-neutral: standard (rotation)
+               IF ( ln_trcldf_triad )   nldf = np_blp_it  ! iso-neutral: triad    (rotation)
+            ENDIF
+            IF ( ln_sco ) THEN             ! s-coordinate
+               IF ( ln_trcldf_lev   )   nldf = np_blp     ! iso-level  (no rotation)
+               IF ( ln_trcldf_hor   )   nldf = np_blp_it  ! horizontal (   rotation)       !!gm   a checker....
+               IF ( ln_trcldf_iso   )   nldf = np_blp_i   ! iso-neutral: standard (rotation)
+               IF ( ln_trcldf_triad )   nldf = np_blp_it  ! iso-neutral: triad    (rotation)
+            ENDIF
+            !                                ! diffusivity ratio: passive / active tracers 
+            IF( ABS(rn_bht_0) < 2._wp*TINY(1._wp) ) THEN
+               IF( ABS(rn_bhtrc_0) < 2._wp*TINY(1._wp) ) THEN
+                  rldf = 1.0_wp
+               ELSE
+                  CALL ctl_stop( 'trc_ldf_ctl : cannot define rldf, rn_aht_0==0, rn_ahtrc_0 /=0' )
+               ENDIF
+            ELSE
+               rldf = SQRT(  ABS( rn_bhtrc_0 / rn_bht_0 )  )
+            ENDIF
          ENDIF
-         IF ( ln_sco ) THEN             ! s-coordinate
-            IF ( ln_trcldf_lev   )   nldf = np_lap     ! iso-level  (no rotation)
-            IF ( ln_trcldf_hor   )   nldf = np_lap_it  ! horizontal (   rotation)       !!gm   a checker....
-            IF ( ln_trcldf_iso   )   nldf = np_lap_i   ! iso-neutral: standard (rotation)
-            IF ( ln_trcldf_triad )   nldf = np_lap_it  ! iso-neutral: triad    (rotation)
-         ENDIF
-         !                                ! diffusivity ratio: passive / active tracers 
-         IF( ABS(rn_aht_0) < 2._wp*TINY(1._wp) ) THEN
-            IF( ABS(rn_ahtrc_0) < 2._wp*TINY(1._wp) ) THEN
-               rldf = 1.0_wp
-            ELSE
-               CALL ctl_stop( 'trc_ldf_ctl : cannot define rldf, rn_aht_0==0, rn_ahtrc_0 /=0' )
-            ENDIF
-         ELSE
-            rldf = rn_ahtrc_0 / rn_aht_0
-         ENDIF
-      ENDIF
-      !
-      IF( ln_trcldf_blp ) THEN      !==  bilaplacian operator  ==!
-         IF ( ln_zco ) THEN                ! z-coordinate
-            IF ( ln_trcldf_lev   )   nldf = np_blp     ! iso-level = horizontal (no rotation)
-            IF ( ln_trcldf_hor   )   nldf = np_blp     ! iso-level = horizontal (no rotation)
-            IF ( ln_trcldf_iso   )   nldf = np_blp_i   ! iso-neutral: standard (rotation)
-            IF ( ln_trcldf_triad )   nldf = np_blp_it  ! iso-neutral: triad    (rotation)
-         ENDIF
-         IF ( ln_zps ) THEN             ! z-coordinate with partial step
-            IF ( ln_trcldf_lev   )   ierr = 1         ! iso-level not allowed 
-            IF ( ln_trcldf_hor   )   nldf = np_blp     ! horizontal (no rotation)
-            IF ( ln_trcldf_iso   )   nldf = np_blp_i   ! iso-neutral: standard (rotation)
-            IF ( ln_trcldf_triad )   nldf = np_blp_it  ! iso-neutral: triad    (rotation)
-         ENDIF
-         IF ( ln_sco ) THEN             ! s-coordinate
-            IF ( ln_trcldf_lev   )   nldf = np_blp     ! iso-level  (no rotation)
-            IF ( ln_trcldf_hor   )   nldf = np_blp_it  ! horizontal (   rotation)       !!gm   a checker....
-            IF ( ln_trcldf_iso   )   nldf = np_blp_i   ! iso-neutral: standard (rotation)
-            IF ( ln_trcldf_triad )   nldf = np_blp_it  ! iso-neutral: triad    (rotation)
-         ENDIF
-         !                                ! diffusivity ratio: passive / active tracers 
-         IF( ABS(rn_bht_0) < 2._wp*TINY(1._wp) ) THEN
-            IF( ABS(rn_bhtrc_0) < 2._wp*TINY(1._wp) ) THEN
-               rldf = 1.0_wp
-            ELSE
-               CALL ctl_stop( 'trc_ldf_ctl : cannot define rldf, rn_aht_0==0, rn_ahtrc_0 /=0' )
-            ENDIF
-         ELSE
-            rldf = SQRT(  ABS( rn_bhtrc_0 / rn_bht_0 )  )
-         ENDIF
-      ENDIF
-      !
-      IF( ierr == 1 )   CALL ctl_stop( 'trc_ldf_ctl: iso-level in z-partial step, not allowed' )
-      IF( ln_ldfeiv .AND. .NOT.ln_trcldf_iso )   CALL ctl_stop( 'trc_ldf_ctl: eiv requires isopycnal laplacian diffusion' )
+         !
+         IF( ierr == 1 )   CALL ctl_stop( 'trc_ldf_ini: iso-level in z-partial step, not allowed' )
+      ENDIF
+      !
+      IF( ln_ldfeiv .AND. .NOT.ln_trcldf_iso )   CALL ctl_stop( 'trc_ldf_ini: eiv requires isopycnal laplacian diffusion' )
       IF( nldf == 1 .OR. nldf == 3 )   l_ldfslp = .TRUE.    ! slope of neutral surfaces required 
       !
@@ -268,24 +270,16 @@
          WRITE(numout,*)
          SELECT CASE( nldf )
-         CASE( np_no_ldf )   ;   WRITE(numout,*) '          NO lateral diffusion'
-         CASE( np_lap    )   ;   WRITE(numout,*) '          laplacian iso-level operator'
-         CASE( np_lap_i  )   ;   WRITE(numout,*) '          Rotated laplacian operator (standard)'
-         CASE( np_lap_it )   ;   WRITE(numout,*) '          Rotated laplacian operator (triad)'
-         CASE( np_blp    )   ;   WRITE(numout,*) '          bilaplacian iso-level operator'
-         CASE( np_blp_i  )   ;   WRITE(numout,*) '          Rotated bilaplacian operator (standard)'
-         CASE( np_blp_it )   ;   WRITE(numout,*) '          Rotated bilaplacian operator (triad)'
+         CASE( np_no_ldf )   ;   WRITE(numout,*) '      ===>>   NO lateral diffusion'
+         CASE( np_lap    )   ;   WRITE(numout,*) '      ===>>   laplacian iso-level operator'
+         CASE( np_lap_i  )   ;   WRITE(numout,*) '      ===>>   Rotated laplacian operator (standard)'
+         CASE( np_lap_it )   ;   WRITE(numout,*) '      ===>>   Rotated laplacian operator (triad)'
+         CASE( np_blp    )   ;   WRITE(numout,*) '      ===>>   bilaplacian iso-level operator'
+         CASE( np_blp_i  )   ;   WRITE(numout,*) '      ===>>   Rotated bilaplacian operator (standard)'
+         CASE( np_blp_it )   ;   WRITE(numout,*) '      ===>>   Rotated bilaplacian operator (triad)'
          END SELECT
       ENDIF
       !
    END SUBROUTINE trc_ldf_ini
-#else
-   !!----------------------------------------------------------------------
-   !!   Default option                                         Empty module
-   !!----------------------------------------------------------------------
-CONTAINS
-   SUBROUTINE trc_ldf( kt )
-      INTEGER, INTENT(in) :: kt
-      WRITE(*,*) 'trc_ldf: You should not have seen this print! error?', kt
-   END SUBROUTINE trc_ldf
+
 #endif
    !!======================================================================
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/TRP/trcnxt.F90	(revision 9019)
@@ -28,6 +28,4 @@
    USE oce_trc         ! ocean dynamics and tracers variables
    USE trc             ! ocean passive tracers variables
-   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
-   USE prtctl_trc      ! Print control for debbuging
    USE trd_oce
    USE trdtra
@@ -38,9 +36,12 @@
    USE agrif_top_interp
 # endif
+   !
+   USE lbclnk          ! ocean lateral boundary conditions (or mpp link)
+   USE prtctl_trc      ! Print control for debbuging
 
    IMPLICIT NONE
    PRIVATE
 
-   PUBLIC   trc_nxt          ! routine called by step.F90
+   PUBLIC   trc_nxt   ! routine called by step.F90
 
    REAL(wp) ::   rfact1, rfact2
@@ -82,5 +83,5 @@
       REAL(wp) ::   zfact            ! temporary scalar
       CHARACTER (len=22) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) ::  ztrdt 
+      REAL(wp), ALLOCATABLE, DIMENSION(:,:,:,:) ::   ztrdt    ! 4D workspace
       !!----------------------------------------------------------------------
       !
@@ -102,5 +103,5 @@
 
       IF( l_trdtrc )  THEN             ! trends: store now fields before the Asselin filter application
-         CALL wrk_alloc( jpi, jpj, jpk, jptra, ztrdt )
+         ALLOCATE( ztrdt(jpi,jpj,jpk,jptra) )
          ztrdt(:,:,:,:)  = trn(:,:,:,:)
       ENDIF
@@ -138,5 +139,5 @@
             END DO
          END DO
-         CALL wrk_dealloc( jpi, jpj, jpk, jptra, ztrdt ) 
+         DEALLOCATE( ztrdt ) 
       END IF
       !
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/TRP/trcsbc.F90	(revision 9019)
@@ -58,14 +58,12 @@
       !!
       !!----------------------------------------------------------------------
-      !
-      INTEGER, INTENT( in ) ::   kt          ! ocean time-step index
-      !
-      INTEGER  ::   ji, jj, jn                                     ! dummy loop indices
-      REAL(wp) ::   zse3t, zrtrn, zratio, zfact                    ! temporary scalars
-      REAL(wp) ::   zswitch, zftra, zcd, zdtra, ztfx, ztra         ! temporary scalars
+      INTEGER, INTENT(in) ::   kt   ! ocean time-step index
+      !
+      INTEGER  ::   ji, jj, jn                      ! dummy loop indices
+      REAL(wp) ::   zse3t, zrtrn, zratio, zfact     ! local scalars
+      REAL(wp) ::   zftra, zcd, zdtra, ztfx, ztra   !   -      -
       CHARACTER (len=22) :: charout
-      REAL(wp), POINTER, DIMENSION(:,:  ) :: zsfx
-      REAL(wp), POINTER, DIMENSION(:,:,:) :: ztrtrd
-
+      REAL(wp), POINTER, DIMENSION(:,:)   ::   zsfx
+      REAL(wp), POINTER, DIMENSION(:,:,:) ::   ztrtrd
       !!---------------------------------------------------------------------
       !
@@ -77,10 +75,4 @@
       !
       zrtrn = 1.e-15_wp
-
-      SELECT CASE( nn_ice_embd )         ! levitating or embedded sea-ice option
-         CASE( 0    )   ;   zswitch = 1  ! (0) standard levitating sea-ice : salt exchange only
-         CASE( 1, 2 )   ;   zswitch = 0  ! (1) levitating sea-ice: salt and volume exchange but no pressure effect                                
-      !                                  ! (2) embedded sea-ice : salt and volume fluxes and pressure
-      END SELECT
 
       IF( kt == nittrc000 ) THEN
@@ -88,5 +80,5 @@
          IF(lwp) WRITE(numout,*) 'trc_sbc : Passive tracers surface boundary condition'
          IF(lwp) WRITE(numout,*) '~~~~~~~ '
-
+         !
          IF( ln_rsttr .AND. .NOT.ln_top_euler .AND.   &                     ! Restart: read in restart  file
             iom_varid( numrtr, 'sbc_'//TRIM(ctrcnm(1))//'_b', ldstop = .FALSE. ) > 0 ) THEN
@@ -125,7 +117,6 @@
          !
          IF( l_trdtrc )   ztrtrd(:,:,:) = tra(:,:,:,jn)  ! save trends
-
-         IF ( nn_ice_tr == -1 ) THEN  ! No tracers in sea ice (null concentration in sea ice)
-
+         !
+         IF( nn_ice_tr == -1 ) THEN    ! No tracers in sea ice (null concentration in sea ice)
             DO jj = 2, jpj
                DO ji = fs_2, fs_jpim1   ! vector opt.
@@ -133,7 +124,5 @@
                END DO
             END DO
-
          ELSE
-
             DO jj = 2, jpj
                DO ji = fs_2, fs_jpim1   ! vector opt.
@@ -142,9 +131,9 @@
                   zftra = - trc_i(ji,jj,jn) * fmmflx(ji,jj) ! uptake of tracer in the sea ice
                   zcd   =   trc_o(ji,jj,jn) * fmmflx(ji,jj) ! concentration dilution due to freezing-melting,
-                                                               ! only used in the levitating sea ice case
+                  !                                         ! only used in the levitating sea ice case
                   ! tracer flux only       : add concentration dilution term in net tracer flux, no F-M in volume flux
                   ! tracer and mass fluxes : no concentration dilution term in net tracer flux, F-M term in volume flux
-                  ztfx  = zftra + zswitch * zcd                ! net tracer flux (+C/D if no ice/ocean mass exchange)
-   
+                  ztfx  = zftra                             ! net tracer flux
+                  !
                   zdtra = r1_rau0 * ( ztfx + zsfx(ji,jj) * trn(ji,jj,1,jn) ) 
                   IF ( zdtra < 0. ) THEN
@@ -173,5 +162,5 @@
       END DO                                                     ! tracer loop
       !                                                          ! ===========
-
+      !
       !                                           Write in the tracer restar  file
       !                                          *******************************
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/TRP/trctrp.F90	(revision 9019)
@@ -15,5 +15,4 @@
    USE oce_trc         ! ocean dynamics and active tracers variables
    USE trc             ! ocean passive tracers variables 
-   USE trabbl          ! bottom boundary layer               (trc_bbl routine)
    USE trcbbl          ! bottom boundary layer               (trc_bbl routine)
    USE trcdmp          ! internal damping                    (trc_dmp routine)
@@ -63,5 +62,5 @@
          !
                                 CALL trc_sbc    ( kt )      ! surface boundary condition
-         IF( lk_trabbl )        CALL trc_bbl    ( kt )      ! advective (and/or diffusive) bottom boundary layer scheme
+         IF( ln_trabbl )        CALL trc_bbl    ( kt )      ! advective (and/or diffusive) bottom boundary layer scheme
          IF( ln_trcdmp )        CALL trc_dmp    ( kt )      ! internal damping trends
          IF( ln_bdy )           CALL trc_bdy_dmp( kt )      ! BDY damping trends
Index: /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90
===================================================================
--- /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 9018)
+++ /branches/2017/dev_merge_2017/NEMOGCM/NEMO/TOP_SRC/TRP/trczdf.F90	(revision 9019)
@@ -4,6 +4,7 @@
    !! Ocean Passive tracers : vertical diffusive trends 
    !!=====================================================================
-   !! History :  9.0  ! 2005-11 (G. Madec)  Original code
+   !! History :  9.0  ! 2005-11  (G. Madec)  Original code
    !!       NEMO 3.0  ! 2008-01  (C. Ethe, G. Madec)  merge TRC-TRA 
+   !!            4.0  ! 2017-04  (G. Madec)  remove the explicit case
    !!----------------------------------------------------------------------
 #if defined key_top
@@ -11,13 +12,13 @@
    !!   'key_top'                                                TOP models
    !!----------------------------------------------------------------------
-   !!   trc_zdf      : update the tracer trend with the lateral diffusion
-   !!   trc_zdf_ini  : initialization, namelist read, and parameters control
+   !!   trc_zdf      : update the tracer trend with the vertical diffusion
    !!----------------------------------------------------------------------
    USE trc           ! ocean passive tracers variables
    USE oce_trc       ! ocean dynamics and active tracers
    USE trd_oce       ! trends: ocean variables
-   USE trazdf_exp    ! vertical diffusion: explicit (tra_zdf_exp     routine)
-   USE trazdf_imp    ! vertical diffusion: implicit (tra_zdf_imp     routine)
+   USE trazdf        ! tracer: vertical diffusion
+!!gm do we really need this ?
    USE trcldf        ! passive tracers: lateral diffusion
+!!gm
    USE trdtra        ! trends manager: tracers 
    USE prtctl_trc    ! Print control
@@ -27,15 +28,5 @@
 
    PUBLIC   trc_zdf         ! called by step.F90 
-   PUBLIC   trc_zdf_ini     ! called by nemogcm.F90 
    
-   !                                        !!** Vertical diffusion (nam_trczdf) **
-   LOGICAL , PUBLIC ::   ln_trczdf_exp       !: explicit vertical diffusion scheme flag
-   INTEGER , PUBLIC ::   nn_trczdf_exp       !: number of sub-time step (explicit time stepping)
-
-   INTEGER ::   nzdf = 0               ! type vertical diffusion algorithm used
-      !                                ! defined from ln_zdf...  namlist logicals)
-   !! * Substitutions
-#  include "zdfddm_substitute.h90"
-#  include "vectopt_loop_substitute.h90"
    !!----------------------------------------------------------------------
    !! NEMO/TOP 3.7 , NEMO Consortium (2015)
@@ -49,5 +40,6 @@
       !!                  ***  ROUTINE trc_zdf  ***
       !!
-      !! ** Purpose :   compute the vertical ocean tracer physics.
+      !! ** Purpose :   compute the vertical ocean tracer physics using
+      !!              an implicit time-stepping scheme.
       !!---------------------------------------------------------------------
       INTEGER, INTENT( in ) ::  kt      ! ocean time-step index
@@ -55,19 +47,13 @@
       INTEGER               ::  jk, jn
       CHARACTER (len=22)    :: charout
-      REAL(wp), POINTER, DIMENSION(:,:,:,:) ::   ztrtrd   ! 4D workspace
+      REAL(wp), DIMENSION(jpi,jpj,jpk,jptra) ::   ztrtrd   ! 4D workspace
       !!---------------------------------------------------------------------
       !
       IF( nn_timing == 1 )  CALL timing_start('trc_zdf')
       !
-      IF( l_trdtrc )  THEN
-         CALL wrk_alloc( jpi, jpj, jpk, jptra, ztrtrd )
-         ztrtrd(:,:,:,:)  = tra(:,:,:,:)
-      ENDIF
-
-      SELECT CASE ( nzdf )                       ! compute lateral mixing trend and add it to the general trend
-      CASE ( 0 ) ;  CALL tra_zdf_exp( kt, nittrc000, 'TRC', r2dttrc, nn_trczdf_exp, trb, tra, jptra )    !   explicit scheme 
-      CASE ( 1 ) ;  CALL tra_zdf_imp( kt, nittrc000, 'TRC', r2dttrc,                trb, tra, jptra )    !   implicit scheme          
-      END SELECT
-
+      IF( l_trdtrc )   ztrtrd(:,:,:,:)  = tra(:,:,:,:)
+      !
+      CALL tra_zdf_imp( kt, nittrc000, 'TRC', r2dttrc, trb, tra, jptra )    !   implicit scheme          
+      !
       IF( l_trdtrc )   THEN                      ! save the vertical diffusive trends for further diagnostics
          DO jn = 1, jptra
@@ -77,10 +63,10 @@
             CALL trd_tra( kt, 'TRC', jn, jptra_zdf, ztrtrd(:,:,:,jn) )
          END DO
-         CALL wrk_dealloc( jpi, jpj, jpk, jptra, ztrtrd )
       ENDIF
       !                                          ! print mean trends (used for debugging)
       IF( ln_ctl )   THEN
-         WRITE(charout, FMT="('zdf ')") ;  CALL prt_ctl_trc_info(charout)
-                                           CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
+         WRITE(charout, FMT="('zdf ')")
+         CALL prt_ctl_trc_info(charout)
+         CALL prt_ctl_trc( tab4d=tra, mask=tmask, clinfo=ctrcnm, clinfo2='trd' )
       END IF
       !
@@ -88,64 +74,4 @@
       !
    END SUBROUTINE trc_zdf
-
-
-   SUBROUTINE trc_zdf_ini
-      !!----------------------------------------------------------------------
-      !!                 ***  ROUTINE trc_zdf_ini  ***
-      !!
-      !! ** Purpose :   Choose the vertical mixing scheme
-      !!
-      !! ** Method  :   Set nzdf from ln_zdfexp
-      !!      nzdf = 0   explicit (time-splitting) scheme (ln_trczdf_exp=T)
-      !!           = 1   implicit (euler backward) scheme (ln_trczdf_exp=F)
-      !!      NB: The implicit scheme is required when using : 
-      !!             - rotated lateral mixing operator
-      !!             - TKE, GLS vertical mixing scheme
-      !!----------------------------------------------------------------------
-      INTEGER ::  ios                 ! Local integer output status for namelist read
-      !!
-      NAMELIST/namtrc_zdf/ ln_trczdf_exp  , nn_trczdf_exp
-      !!----------------------------------------------------------------------
-      !
-      REWIND( numnat_ref )             ! namtrc_zdf in reference namelist 
-      READ  ( numnat_ref, namtrc_zdf, IOSTAT = ios, ERR = 905)
-905   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_zdf in reference namelist', lwp )
-      !
-      REWIND( numnat_cfg )             ! namtrc_zdf in configuration namelist 
-      READ  ( numnat_cfg, namtrc_zdf, IOSTAT = ios, ERR = 906 )
-906   IF( ios /= 0 ) CALL ctl_nam ( ios , 'namtrc_zdf in configuration namelist', lwp )
-      IF(lwm) WRITE ( numont, namtrc_zdf )
-      !
-      IF(lwp) THEN                     ! Control print
-         WRITE(numout,*)
-         WRITE(numout,*) '   Namelist namtrc_zdf : set vertical diffusion  parameters'
-         WRITE(numout,*) '      time splitting / backward scheme ln_trczdf_exp = ', ln_trczdf_exp
-         WRITE(numout,*) '      number of time step              nn_trczdf_exp = ', nn_trczdf_exp
-      ENDIF
-
-      !                                ! Define the vertical tracer physics scheme
-      IF( ln_trczdf_exp ) THEN   ;   nzdf = 0     ! explicit scheme
-      ELSE                       ;   nzdf = 1     ! implicit scheme
-      ENDIF
-
-      !                                ! Force implicit schemes
-      IF( ln_trcldf_iso              )   nzdf = 1      ! iso-neutral lateral physics
-      IF( ln_trcldf_hor .AND. ln_sco )   nzdf = 1      ! horizontal lateral physics in s-coordinate
-#if defined key_zdftke || defined key_zdfgls 
-                                         nzdf = 1      ! TKE or GLS physics       
-#endif
-      IF( ln_trczdf_exp .AND. nzdf == 1 )  & 
-         CALL ctl_stop( 'trc_zdf : If using the rotated lateral mixing operator or TKE, GLS vertical scheme ', &
-            &           '          the implicit scheme is required, set ln_trczdf_exp = .false.' )
-
-      IF(lwp) THEN
-         WRITE(numout,*)
-         WRITE(numout,*) 'trc:zdf_ctl : vertical passive tracer physics scheme'
-         WRITE(numout,*) '~~~~~~~~~~~'
-         IF( nzdf ==  0 )   WRITE(numout,*) '              Explicit time-splitting scheme'
-         IF( nzdf ==  1 )   WRITE(numout,*) '              Implicit (euler backward) scheme'
-      ENDIF
-      !
-   END SUBROUTINE trc_zdf_ini
    
 #else
